Subject: Re: Porting Cygwin
From: "David Feustel" <[email-masked]>
To: <[email-masked]>
Date: Sat, 6 Jan 2001 12:19:32 -0500

----- Original Message ----- 
From: "Christopher Faylor" <[email-masked]>
To: <[email-masked]>
Cc: <[email-masked]>
Sent: Saturday, January 06, 2001 11:54 AM
Subject: Re: Porting Cygwin

> On Sat, Jan 06, 2001 at 08:36:57AM -0800, Tim Prince wrote:
> >> Thanks, I'm on the list.
> >>
> >> Now, am I correct in my assumption that porting
> >> the cygwin dll to WinCE will let me compile,
> >> GCC source and the link/run it using the EVT
> >> c compiler with not a whole lot of editing?
> >>
> >> If so, where can I find the makefile for the cygwin dll?
> >>
> >> Thanks,
> >>
> >> Dave Feustel
> >
> >Does CE support fork?  That has been missing from certain Windows
> >variants. gcc usually has to be ported by starting with a cross build,
> >using a working gcc, e.g. on linux.
> 
> Fork is actually missing from every version of Windows.  Or rather, the
> POSIX layer on Windows NT supports it but cygwin doesn't use that.
> 
> Cygwin has always rolled its own version of fork.
> 
> Porting cygwin to Windows CE will be a nearly impossible task,
> especially if you (Dave) are having problems just locating subscribing
> to the mailing list and finding the Makefile.  This indicates to me that
> you probably are not fully aware of the amount of effort required.
> 
> The subset of the Windows API that is available for Windows CE is not
> sufficient to get cygwin working.  The biggest problem is that there is
> no equivalent to the Windows console.

WinCE 2.11 has a console window. I am using it in my ports
of Teco and Snobol4 to my Jornada 820. Teco is essentially done. 
Snobol4 runs but needs work. I have a Windows 2000 version
running from essentially the same codebase which is helping me
figure out what should be happening with Snobol on my Jornada.

I'm now starting a port of Unicon, but if I could get (even a subset of) 
cygwin dll running on WinCE, it would save me a lot of work porting other programs.

> If you want to create a cross-compiler, that's certainly doable.  You
> don't have to port cygwin to create a compiler that will generate
> executables for Windows CE.  In fact, there is already support for
> certain versions of Windows CE in the sources available in CVS on
> sources.redhat.com.
> 
> Unfortunately, you need Microsoft's publicly available SDK in order to
> build the toolchains and, later, to develop application programs.
> You'll have to search around on the microsoft site for those.  They keep
> moving things around for some reason.

I have EVT 3.0 and an MSDN subscription as well as Visual Studio 6.
I've been using MKS Toolkit for a while too.

> Basically, unless you are either already familiar with building
> toolchains and working with gcc, gas, binutils, ld, and gdb, you will be
> needing to spend a large amount of time getting up to speed.  And, since
> there is no cookbook for doing what you need, you'll have to rely on
> trial-and-error and the vagaries of help from mailing lists.

So what else is new? :-)

> cgf

--
Want to unsubscribe from this list?
Check out: http://cygwin.com/ml/#unsubscribe-simple